<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>polylib: errors.c File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>File&nbsp;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>errors.c File Reference</h1><code>#include &lt;stdio.h&gt;</code><br/>
<code>#include &lt;stdlib.h&gt;</code><br/>
<code>#include &lt;string.h&gt;</code><br/>
<code>#include &quot;<a class="el" href="include_2polylib_2arithmetique_8h_source.html">arithmetique.h</a>&quot;</code><br/>

<p><a href="errors_8c_source.html">Go to the source code of this file.</a></p>
<table border="0" cellpadding="0" cellspacing="0">
<tr><td colspan="2"><h2>Classes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structlinear__exception__holder.html">linear_exception_holder</a></td></tr>
<tr><td colspan="2"><h2>Defines</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="errors_8c.html#aa93f0eb578d23995850d61f7d61c55c1">FALSE</a>&nbsp;&nbsp;&nbsp;0</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="errors_8c.html#aa8cecfc5c5c054d2875c03e77b7be15d">TRUE</a>&nbsp;&nbsp;&nbsp;1</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="errors_8c.html#aaec70e82a04c1102db5789b0c8092055">MAX_STACKED_CONTEXTS</a>&nbsp;&nbsp;&nbsp;64</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="errors_8c.html#a8d4a2127a1edadca61c0631735922769">exception_debug_message</a>(type)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="errors_8c.html#a82fa865508693149b63d670fa7d7c438">exception_debug_trace</a>(type)&nbsp;&nbsp;&nbsp;if (<a class="el" href="errors_8c.html#a0471cbbdd66a5ee1fa3a459878c756be">linear_exception_debug_mode</a>) { exception_debug_message(type); }</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="errors_8c.html#ac32f3590ee78925a812d8718f28e9a2b">same_string_p</a>(s1, s2)&nbsp;&nbsp;&nbsp;(strcmp((s1),(s2))==0)</td></tr>
<tr><td colspan="2"><h2>Typedefs</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="errors_8c.html#a621c38f1f10a1c565d897e3178b16d6e">boolean</a></td></tr>
<tr><td colspan="2"><h2>Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">const char *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="errors_8c.html#a79edc2c9a0ce7b3159417f9130a14def">get_exception_name</a> (unsigned int exception)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="errors_8c.html#a93de4c04224b53c462a8bd9242edd3ed">set_exception_callbacks</a> (<a class="el" href="source_2arith_2arithmetic__errors_8h.html#aafc39b4cb7a07fefadbdaeb9f8753679">exception_callback_t</a> push, <a class="el" href="source_2arith_2arithmetic__errors_8h.html#aafc39b4cb7a07fefadbdaeb9f8753679">exception_callback_t</a> pop)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="errors_8c.html#a528a38285a81d0501a9942a7941163ab">dump_exception_stack_to_file</a> (FILE *f)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="errors_8c.html#a14b32c4f73df3d2d17000b401db5d88a">dump_exception_stack</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">jmp_buf *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="errors_8c.html#a6506ceda3a14deda94141a42d0b3ae4b">push_exception_on_stack</a> (int what, const char *function, const char *file, int line)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="errors_8c.html#af00ac00cc6c96f681274c7d1743e034a">pop_exception_from_stack</a> (int what, const char *function, const char *file, int line)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="errors_8c.html#a328c6d73c9b785c2d853434eeac83883">throw_exception</a> (int what, const char *function, const char *file, int line)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="errors_8c.html#a0b645a3ab909b237aebbf6b31560705c">linear_initialize_exception_stack</a> (unsigned int verbose_exceptions, <a class="el" href="source_2arith_2arithmetic__errors_8h.html#aafc39b4cb7a07fefadbdaeb9f8753679">exception_callback_t</a> push, <a class="el" href="source_2arith_2arithmetic__errors_8h.html#aafc39b4cb7a07fefadbdaeb9f8753679">exception_callback_t</a> pop)</td></tr>
<tr><td colspan="2"><h2>Variables</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">unsigned int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="errors_8c.html#af74135a8750c28205f819842ae8be9c9">overflow_error</a> = 1</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">unsigned int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="errors_8c.html#a381d67b7ee03ff84c242d6f342fa063c">simplex_arithmetic_error</a> = 2</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">unsigned int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="errors_8c.html#a18b35523d2702706b86f2ab8ae2393d2">user_exception_error</a> = 4</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">unsigned int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="errors_8c.html#a3806d9a2c0134fd8bef8c192341a8954">parser_exception_error</a> = 8</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">unsigned int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="errors_8c.html#a3cae90a91b95e5365e192179877cccf9">timeout_error</a> = 16</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">unsigned int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="errors_8c.html#a3fbedc713824754a33dd94278851fe70">any_exception_error</a> = ~0</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">unsigned int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="errors_8c.html#a9dbd1094abce0128b2995c91d701349d">the_last_just_thrown_exception</a> = 0</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="errors_8c.html#a0471cbbdd66a5ee1fa3a459878c756be">linear_exception_debug_mode</a> = FALSE</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static unsigned int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="errors_8c.html#a3e54f04e8bd9d204f2ad4dcd32ac744f">linear_exception_verbose</a> = 1 | 2 | 16</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <a class="el" href="structlinear__exception__holder.html">linear_exception_holder</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="errors_8c.html#ae7d6c7530e7505f175ee1efaf0dd33e1">exception_stack</a> [MAX_STACKED_CONTEXTS]</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="errors_8c.html#ad63e2e9e42900784d7f912727fc90af3">exception_index</a> = 0</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <a class="el" href="source_2arith_2arithmetic__errors_8h.html#aafc39b4cb7a07fefadbdaeb9f8753679">exception_callback_t</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="errors_8c.html#a949dce609af01654ccefedf9473eac29">push_callback</a> = NULL</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <a class="el" href="source_2arith_2arithmetic__errors_8h.html#aafc39b4cb7a07fefadbdaeb9f8753679">exception_callback_t</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="errors_8c.html#a5cb3be87cd274e085213bafc6eca475f">pop_callback</a> = NULL</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="errors_8c.html#a3313c41a656ee03e88a9d00234cfc5ec">linear_number_of_exception_thrown</a> = 0</td></tr>
</table>
<hr/><h2>Define Documentation</h2>
<a class="anchor" id="a8d4a2127a1edadca61c0631735922769"></a><!-- doxytag: member="errors.c::exception_debug_message" ref="a8d4a2127a1edadca61c0631735922769" args="(type)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define exception_debug_message</td>
          <td>(</td>
          <td class="paramtype">type&nbsp;</td>
          <td class="paramname"></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<b>Value:</b><div class="fragment"><pre class="fragment">fprintf(stderr, <span class="stringliteral">&quot;%s[%s:%d %s (%d)/%d]\n&quot;</span>,                         \
            type, file, line, function, what, <a class="code" href="errors_8c.html#ad63e2e9e42900784d7f912727fc90af3">exception_index</a>)
</pre></div>
<p>Definition at line <a class="el" href="errors_8c_source.html#l00238">238</a> of file <a class="el" href="errors_8c_source.html">errors.c</a>.</p>

<p>Referenced by <a class="el" href="errors_8c_source.html#l00285">pop_exception_from_stack()</a>, <a class="el" href="errors_8c_source.html#l00249">push_exception_on_stack()</a>, and <a class="el" href="errors_8c_source.html#l00329">throw_exception()</a>.</p>

</div>
</div>
<a class="anchor" id="a82fa865508693149b63d670fa7d7c438"></a><!-- doxytag: member="errors.c::exception_debug_trace" ref="a82fa865508693149b63d670fa7d7c438" args="(type)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define exception_debug_trace</td>
          <td>(</td>
          <td class="paramtype">type&nbsp;</td>
          <td class="paramname"></td>
          <td>&nbsp;)&nbsp;</td>
          <td>&nbsp;&nbsp;&nbsp;if (<a class="el" href="errors_8c.html#a0471cbbdd66a5ee1fa3a459878c756be">linear_exception_debug_mode</a>) { exception_debug_message(type); }</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="errors_8c_source.html#l00242">242</a> of file <a class="el" href="errors_8c_source.html">errors.c</a>.</p>

<p>Referenced by <a class="el" href="errors_8c_source.html#l00285">pop_exception_from_stack()</a>, <a class="el" href="errors_8c_source.html#l00249">push_exception_on_stack()</a>, and <a class="el" href="errors_8c_source.html#l00329">throw_exception()</a>.</p>

</div>
</div>
<a class="anchor" id="aa93f0eb578d23995850d61f7d61c55c1"></a><!-- doxytag: member="errors.c::FALSE" ref="aa93f0eb578d23995850d61f7d61c55c1" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define FALSE&nbsp;&nbsp;&nbsp;0</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="errors_8c_source.html#l00130">130</a> of file <a class="el" href="errors_8c_source.html">errors.c</a>.</p>

</div>
</div>
<a class="anchor" id="aaec70e82a04c1102db5789b0c8092055"></a><!-- doxytag: member="errors.c::MAX_STACKED_CONTEXTS" ref="aaec70e82a04c1102db5789b0c8092055" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define MAX_STACKED_CONTEXTS&nbsp;&nbsp;&nbsp;64</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="errors_8c_source.html#l00187">187</a> of file <a class="el" href="errors_8c_source.html">errors.c</a>.</p>

<p>Referenced by <a class="el" href="errors_8c_source.html#l00249">push_exception_on_stack()</a>.</p>

</div>
</div>
<a class="anchor" id="ac32f3590ee78925a812d8718f28e9a2b"></a><!-- doxytag: member="errors.c::same_string_p" ref="ac32f3590ee78925a812d8718f28e9a2b" args="(s1, s2)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define same_string_p</td>
          <td>(</td>
          <td class="paramtype">s1, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">s2&nbsp;</td>
          <td class="paramname"></td>
          <td>&nbsp;)&nbsp;</td>
          <td>&nbsp;&nbsp;&nbsp;(strcmp((s1),(s2))==0)</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="errors_8c_source.html#l00278">278</a> of file <a class="el" href="errors_8c_source.html">errors.c</a>.</p>

<p>Referenced by <a class="el" href="errors_8c_source.html#l00285">pop_exception_from_stack()</a>.</p>

</div>
</div>
<a class="anchor" id="aa8cecfc5c5c054d2875c03e77b7be15d"></a><!-- doxytag: member="errors.c::TRUE" ref="aa8cecfc5c5c054d2875c03e77b7be15d" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define TRUE&nbsp;&nbsp;&nbsp;1</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="errors_8c_source.html#l00133">133</a> of file <a class="el" href="errors_8c_source.html">errors.c</a>.</p>

</div>
</div>
<hr/><h2>Typedef Documentation</h2>
<a class="anchor" id="a621c38f1f10a1c565d897e3178b16d6e"></a><!-- doxytag: member="errors.c::boolean" ref="a621c38f1f10a1c565d897e3178b16d6e" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef int <a class="el" href="errors_8c.html#a621c38f1f10a1c565d897e3178b16d6e">boolean</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="errors_8c_source.html#l00127">127</a> of file <a class="el" href="errors_8c_source.html">errors.c</a>.</p>

</div>
</div>
<hr/><h2>Function Documentation</h2>
<a class="anchor" id="a14b32c4f73df3d2d17000b401db5d88a"></a><!-- doxytag: member="errors.c::dump_exception_stack" ref="a14b32c4f73df3d2d17000b401db5d88a" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void dump_exception_stack </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname"></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="errors_8c_source.html#l00233">233</a> of file <a class="el" href="errors_8c_source.html">errors.c</a>.</p>

<p>References <a class="el" href="errors_8c_source.html#l00216">dump_exception_stack_to_file()</a>.</p>

<p>Referenced by <a class="el" href="errors_8c_source.html#l00285">pop_exception_from_stack()</a>, <a class="el" href="errors_8c_source.html#l00249">push_exception_on_stack()</a>, and <a class="el" href="errors_8c_source.html#l00329">throw_exception()</a>.</p>

</div>
</div>
<a class="anchor" id="a528a38285a81d0501a9942a7941163ab"></a><!-- doxytag: member="errors.c::dump_exception_stack_to_file" ref="a528a38285a81d0501a9942a7941163ab" args="(FILE *f)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void dump_exception_stack_to_file </td>
          <td>(</td>
          <td class="paramtype">FILE *&nbsp;</td>
          <td class="paramname"> <em>f</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="errors_8c_source.html#l00216">216</a> of file <a class="el" href="errors_8c_source.html">errors.c</a>.</p>

<p>References <a class="el" href="errors_8c_source.html#l00189">exception_index</a>.</p>

<p>Referenced by <a class="el" href="errors_8c_source.html#l00233">dump_exception_stack()</a>.</p>

</div>
</div>
<a class="anchor" id="a79edc2c9a0ce7b3159417f9130a14def"></a><!-- doxytag: member="errors.c::get_exception_name" ref="a79edc2c9a0ce7b3159417f9130a14def" args="(unsigned int exception)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const char* get_exception_name </td>
          <td>(</td>
          <td class="paramtype">unsigned int&nbsp;</td>
          <td class="paramname"> <em>exception</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="errors_8c_source.html#l00136">136</a> of file <a class="el" href="errors_8c_source.html">errors.c</a>.</p>

<p>References <a class="el" href="errors_8c_source.html#l00116">any_exception_error</a>, <a class="el" href="errors_8c_source.html#l00109">overflow_error</a>, <a class="el" href="errors_8c_source.html#l00112">parser_exception_error</a>, <a class="el" href="errors_8c_source.html#l00110">simplex_arithmetic_error</a>, <a class="el" href="errors_8c_source.html#l00113">timeout_error</a>, and <a class="el" href="errors_8c_source.html#l00111">user_exception_error</a>.</p>

</div>
</div>
<a class="anchor" id="a0b645a3ab909b237aebbf6b31560705c"></a><!-- doxytag: member="errors.c::linear_initialize_exception_stack" ref="a0b645a3ab909b237aebbf6b31560705c" args="(unsigned int verbose_exceptions, exception_callback_t push, exception_callback_t pop)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void linear_initialize_exception_stack </td>
          <td>(</td>
          <td class="paramtype">unsigned int&nbsp;</td>
          <td class="paramname"> <em>verbose_exceptions</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="source_2arith_2arithmetic__errors_8h.html#aafc39b4cb7a07fefadbdaeb9f8753679">exception_callback_t</a>&nbsp;</td>
          <td class="paramname"> <em>push</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="source_2arith_2arithmetic__errors_8h.html#aafc39b4cb7a07fefadbdaeb9f8753679">exception_callback_t</a>&nbsp;</td>
          <td class="paramname"> <em>pop</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="errors_8c_source.html#l00384">384</a> of file <a class="el" href="errors_8c_source.html">errors.c</a>.</p>

<p>References <a class="el" href="errors_8c_source.html#l00161">linear_exception_verbose</a>, and <a class="el" href="errors_8c_source.html#l00196">set_exception_callbacks()</a>.</p>

</div>
</div>
<a class="anchor" id="af00ac00cc6c96f681274c7d1743e034a"></a><!-- doxytag: member="errors.c::pop_exception_from_stack" ref="af00ac00cc6c96f681274c7d1743e034a" args="(int what, const char *function, const char *file, int line)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void pop_exception_from_stack </td>
          <td>(</td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>what</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&nbsp;</td>
          <td class="paramname"> <em>function</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&nbsp;</td>
          <td class="paramname"> <em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>line</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="errors_8c_source.html#l00285">285</a> of file <a class="el" href="errors_8c_source.html">errors.c</a>.</p>

<p>References <a class="el" href="errors_8c_source.html#l00233">dump_exception_stack()</a>, <a class="el" href="errors_8c_source.html#l00238">exception_debug_message</a>, <a class="el" href="errors_8c_source.html#l00242">exception_debug_trace</a>, <a class="el" href="errors_8c_source.html#l00189">exception_index</a>, <a class="el" href="errors_8c_source.html#l00194">pop_callback</a>, <a class="el" href="errors_8c_source.html#l00278">same_string_p</a>, and <a class="el" href="errors_8c_source.html#l00156">the_last_just_thrown_exception</a>.</p>

</div>
</div>
<a class="anchor" id="a6506ceda3a14deda94141a42d0b3ae4b"></a><!-- doxytag: member="errors.c::push_exception_on_stack" ref="a6506ceda3a14deda94141a42d0b3ae4b" args="(int what, const char *function, const char *file, int line)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">jmp_buf* push_exception_on_stack </td>
          <td>(</td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>what</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&nbsp;</td>
          <td class="paramname"> <em>function</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&nbsp;</td>
          <td class="paramname"> <em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>line</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="errors_8c_source.html#l00249">249</a> of file <a class="el" href="errors_8c_source.html">errors.c</a>.</p>

<p>References <a class="el" href="errors_8c_source.html#l00233">dump_exception_stack()</a>, <a class="el" href="errors_8c_source.html#l00238">exception_debug_message</a>, <a class="el" href="errors_8c_source.html#l00242">exception_debug_trace</a>, <a class="el" href="errors_8c_source.html#l00189">exception_index</a>, <a class="el" href="errors_8c_source.html#l00178">linear_exception_holder::file</a>, <a class="el" href="errors_8c_source.html#l00177">linear_exception_holder::function</a>, <a class="el" href="errors_8c_source.html#l00179">linear_exception_holder::line</a>, <a class="el" href="errors_8c_source.html#l00187">MAX_STACKED_CONTEXTS</a>, <a class="el" href="errors_8c_source.html#l00193">push_callback</a>, <a class="el" href="errors_8c_source.html#l00156">the_last_just_thrown_exception</a>, <a class="el" href="errors_8c_source.html#l00169">linear_exception_holder::what</a>, and <a class="el" href="errors_8c_source.html#l00173">linear_exception_holder::where</a>.</p>

</div>
</div>
<a class="anchor" id="a93de4c04224b53c462a8bd9242edd3ed"></a><!-- doxytag: member="errors.c::set_exception_callbacks" ref="a93de4c04224b53c462a8bd9242edd3ed" args="(exception_callback_t push, exception_callback_t pop)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void set_exception_callbacks </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="source_2arith_2arithmetic__errors_8h.html#aafc39b4cb7a07fefadbdaeb9f8753679">exception_callback_t</a>&nbsp;</td>
          <td class="paramname"> <em>push</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="source_2arith_2arithmetic__errors_8h.html#aafc39b4cb7a07fefadbdaeb9f8753679">exception_callback_t</a>&nbsp;</td>
          <td class="paramname"> <em>pop</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="errors_8c_source.html#l00196">196</a> of file <a class="el" href="errors_8c_source.html">errors.c</a>.</p>

<p>References <a class="el" href="errors_8c_source.html#l00194">pop_callback</a>, and <a class="el" href="errors_8c_source.html#l00193">push_callback</a>.</p>

<p>Referenced by <a class="el" href="errors_8c_source.html#l00384">linear_initialize_exception_stack()</a>.</p>

</div>
</div>
<a class="anchor" id="a328c6d73c9b785c2d853434eeac83883"></a><!-- doxytag: member="errors.c::throw_exception" ref="a328c6d73c9b785c2d853434eeac83883" args="(int what, const char *function, const char *file, int line)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void throw_exception </td>
          <td>(</td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>what</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&nbsp;</td>
          <td class="paramname"> <em>function</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&nbsp;</td>
          <td class="paramname"> <em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>line</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="errors_8c_source.html#l00329">329</a> of file <a class="el" href="errors_8c_source.html">errors.c</a>.</p>

<p>References <a class="el" href="errors_8c_source.html#l00233">dump_exception_stack()</a>, <a class="el" href="errors_8c_source.html#l00238">exception_debug_message</a>, <a class="el" href="errors_8c_source.html#l00242">exception_debug_trace</a>, <a class="el" href="errors_8c_source.html#l00189">exception_index</a>, <a class="el" href="errors_8c_source.html#l00160">linear_exception_debug_mode</a>, <a class="el" href="errors_8c_source.html#l00161">linear_exception_verbose</a>, <a class="el" href="errors_8c_source.html#l00212">linear_number_of_exception_thrown</a>, <a class="el" href="errors_8c_source.html#l00194">pop_callback</a>, and <a class="el" href="errors_8c_source.html#l00156">the_last_just_thrown_exception</a>.</p>

</div>
</div>
<hr/><h2>Variable Documentation</h2>
<a class="anchor" id="a3fbedc713824754a33dd94278851fe70"></a><!-- doxytag: member="errors.c::any_exception_error" ref="a3fbedc713824754a33dd94278851fe70" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned int <a class="el" href="include_2polylib_2arithmetique_8h.html#a3fbedc713824754a33dd94278851fe70">any_exception_error</a> = ~0</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="errors_8c_source.html#l00116">116</a> of file <a class="el" href="errors_8c_source.html">errors.c</a>.</p>

<p>Referenced by <a class="el" href="polyhedron_8c_source.html#l02293">AddConstraints()</a>, <a class="el" href="polyhedron_8c_source.html#l02661">AddRays()</a>, <a class="el" href="polyhedron_8c_source.html#l03665">align_context()</a>, <a class="el" href="polyhedron_8c_source.html#l02237">BuildSat()</a>, <a class="el" href="polyhedron_8c_source.html#l00386">Chernikova()</a>, <a class="el" href="polyhedron_8c_source.html#l01906">Constraints2Polyhedron()</a>, <a class="el" href="polyhedron_8c_source.html#l03574">DomainConvex()</a>, <a class="el" href="polyhedron_8c_source.html#l04223">DomainCost()</a>, <a class="el" href="polyhedron_8c_source.html#l04187">DomainImage()</a>, <a class="el" href="polyhedron_8c_source.html#l04061">DomainPreimage()</a>, <a class="el" href="polyhedron_8c_source.html#l02902">FindSimple()</a>, <a class="el" href="polyhedron_8c_source.html#l00734">Gauss4()</a>, <a class="el" href="errors_8c_source.html#l00136">get_exception_name()</a>, <a class="el" href="polyhedron_8c_source.html#l04089">Polyhedron_Image()</a>, <a class="el" href="polyhedron_8c_source.html#l04002">Polyhedron_Preimage()</a>, <a class="el" href="polyhedron_8c_source.html#l02083">Rays2Polyhedron()</a>, <a class="el" href="polyhedron_8c_source.html#l03920">Rays_Mult()</a>, <a class="el" href="polyhedron_8c_source.html#l03959">Rays_Mult_Transpose()</a>, <a class="el" href="polyhedron_8c_source.html#l00859">Remove_Redundants()</a>, <a class="el" href="polyhedron_8c_source.html#l03120">SimplifyConstraints()</a>, <a class="el" href="polyhedron_8c_source.html#l03372">Stras_DomainSimplify()</a>, and <a class="el" href="polyhedron_8c_source.html#l02508">SubConstraint()</a>.</p>

</div>
</div>
<a class="anchor" id="ad63e2e9e42900784d7f912727fc90af3"></a><!-- doxytag: member="errors.c::exception_index" ref="ad63e2e9e42900784d7f912727fc90af3" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="errors_8c.html#ad63e2e9e42900784d7f912727fc90af3">exception_index</a> = 0<code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="errors_8c_source.html#l00189">189</a> of file <a class="el" href="errors_8c_source.html">errors.c</a>.</p>

<p>Referenced by <a class="el" href="errors_8c_source.html#l00216">dump_exception_stack_to_file()</a>, <a class="el" href="errors_8c_source.html#l00285">pop_exception_from_stack()</a>, <a class="el" href="errors_8c_source.html#l00249">push_exception_on_stack()</a>, and <a class="el" href="errors_8c_source.html#l00329">throw_exception()</a>.</p>

</div>
</div>
<a class="anchor" id="ae7d6c7530e7505f175ee1efaf0dd33e1"></a><!-- doxytag: member="errors.c::exception_stack" ref="ae7d6c7530e7505f175ee1efaf0dd33e1" args="[MAX_STACKED_CONTEXTS]" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structlinear__exception__holder.html">linear_exception_holder</a> <a class="el" href="errors_8c.html#ae7d6c7530e7505f175ee1efaf0dd33e1">exception_stack</a>[MAX_STACKED_CONTEXTS]<code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="errors_8c_source.html#l00188">188</a> of file <a class="el" href="errors_8c_source.html">errors.c</a>.</p>

</div>
</div>
<a class="anchor" id="a0471cbbdd66a5ee1fa3a459878c756be"></a><!-- doxytag: member="errors.c::linear_exception_debug_mode" ref="a0471cbbdd66a5ee1fa3a459878c756be" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="errors_8c.html#a0471cbbdd66a5ee1fa3a459878c756be">linear_exception_debug_mode</a> = FALSE<code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="errors_8c_source.html#l00160">160</a> of file <a class="el" href="errors_8c_source.html">errors.c</a>.</p>

<p>Referenced by <a class="el" href="errors_8c_source.html#l00329">throw_exception()</a>.</p>

</div>
</div>
<a class="anchor" id="a3e54f04e8bd9d204f2ad4dcd32ac744f"></a><!-- doxytag: member="errors.c::linear_exception_verbose" ref="a3e54f04e8bd9d204f2ad4dcd32ac744f" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned int <a class="el" href="errors_8c.html#a3e54f04e8bd9d204f2ad4dcd32ac744f">linear_exception_verbose</a> = 1 | 2 | 16<code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="errors_8c_source.html#l00161">161</a> of file <a class="el" href="errors_8c_source.html">errors.c</a>.</p>

<p>Referenced by <a class="el" href="errors_8c_source.html#l00384">linear_initialize_exception_stack()</a>, and <a class="el" href="errors_8c_source.html#l00329">throw_exception()</a>.</p>

</div>
</div>
<a class="anchor" id="a3313c41a656ee03e88a9d00234cfc5ec"></a><!-- doxytag: member="errors.c::linear_number_of_exception_thrown" ref="a3313c41a656ee03e88a9d00234cfc5ec" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="errors_8c.html#a3313c41a656ee03e88a9d00234cfc5ec">linear_number_of_exception_thrown</a> = 0</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="errors_8c_source.html#l00212">212</a> of file <a class="el" href="errors_8c_source.html">errors.c</a>.</p>

<p>Referenced by <a class="el" href="errors_8c_source.html#l00329">throw_exception()</a>.</p>

</div>
</div>
<a class="anchor" id="af74135a8750c28205f819842ae8be9c9"></a><!-- doxytag: member="errors.c::overflow_error" ref="af74135a8750c28205f819842ae8be9c9" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned int <a class="el" href="include_2polylib_2arithmetique_8h.html#af74135a8750c28205f819842ae8be9c9">overflow_error</a> = 1</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="errors_8c_source.html#l00109">109</a> of file <a class="el" href="errors_8c_source.html">errors.c</a>.</p>

<p>Referenced by <a class="el" href="ehrhart_8c_source.html#l02281">Ehrhart_Quick_Apx_Full_Dim()</a>, <a class="el" href="ehrhart_8c_source.html#l01738">Enumerate_NoParameters()</a>, <a class="el" href="errors_8c_source.html#l00136">get_exception_name()</a>, and <a class="el" href="ehrhart_8c_source.html#l01860">Polyhedron_Enumerate()</a>.</p>

</div>
</div>
<a class="anchor" id="a3806d9a2c0134fd8bef8c192341a8954"></a><!-- doxytag: member="errors.c::parser_exception_error" ref="a3806d9a2c0134fd8bef8c192341a8954" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned int <a class="el" href="include_2polylib_2arithmetique_8h.html#a3806d9a2c0134fd8bef8c192341a8954">parser_exception_error</a> = 8</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="errors_8c_source.html#l00112">112</a> of file <a class="el" href="errors_8c_source.html">errors.c</a>.</p>

<p>Referenced by <a class="el" href="errors_8c_source.html#l00136">get_exception_name()</a>.</p>

</div>
</div>
<a class="anchor" id="a5cb3be87cd274e085213bafc6eca475f"></a><!-- doxytag: member="errors.c::pop_callback" ref="a5cb3be87cd274e085213bafc6eca475f" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="source_2arith_2arithmetic__errors_8h.html#aafc39b4cb7a07fefadbdaeb9f8753679">exception_callback_t</a> <a class="el" href="errors_8c.html#a5cb3be87cd274e085213bafc6eca475f">pop_callback</a> = NULL<code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="errors_8c_source.html#l00194">194</a> of file <a class="el" href="errors_8c_source.html">errors.c</a>.</p>

<p>Referenced by <a class="el" href="errors_8c_source.html#l00285">pop_exception_from_stack()</a>, <a class="el" href="errors_8c_source.html#l00196">set_exception_callbacks()</a>, and <a class="el" href="errors_8c_source.html#l00329">throw_exception()</a>.</p>

</div>
</div>
<a class="anchor" id="a949dce609af01654ccefedf9473eac29"></a><!-- doxytag: member="errors.c::push_callback" ref="a949dce609af01654ccefedf9473eac29" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="source_2arith_2arithmetic__errors_8h.html#aafc39b4cb7a07fefadbdaeb9f8753679">exception_callback_t</a> <a class="el" href="errors_8c.html#a949dce609af01654ccefedf9473eac29">push_callback</a> = NULL<code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="errors_8c_source.html#l00193">193</a> of file <a class="el" href="errors_8c_source.html">errors.c</a>.</p>

<p>Referenced by <a class="el" href="errors_8c_source.html#l00249">push_exception_on_stack()</a>, and <a class="el" href="errors_8c_source.html#l00196">set_exception_callbacks()</a>.</p>

</div>
</div>
<a class="anchor" id="a381d67b7ee03ff84c242d6f342fa063c"></a><!-- doxytag: member="errors.c::simplex_arithmetic_error" ref="a381d67b7ee03ff84c242d6f342fa063c" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned int <a class="el" href="include_2polylib_2arithmetique_8h.html#a381d67b7ee03ff84c242d6f342fa063c">simplex_arithmetic_error</a> = 2</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="errors_8c_source.html#l00110">110</a> of file <a class="el" href="errors_8c_source.html">errors.c</a>.</p>

<p>Referenced by <a class="el" href="errors_8c_source.html#l00136">get_exception_name()</a>.</p>

</div>
</div>
<a class="anchor" id="a9dbd1094abce0128b2995c91d701349d"></a><!-- doxytag: member="errors.c::the_last_just_thrown_exception" ref="a9dbd1094abce0128b2995c91d701349d" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned int <a class="el" href="include_2polylib_2arithmetique_8h.html#a9dbd1094abce0128b2995c91d701349d">the_last_just_thrown_exception</a> = 0</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="errors_8c_source.html#l00156">156</a> of file <a class="el" href="errors_8c_source.html">errors.c</a>.</p>

<p>Referenced by <a class="el" href="errors_8c_source.html#l00285">pop_exception_from_stack()</a>, <a class="el" href="errors_8c_source.html#l00249">push_exception_on_stack()</a>, and <a class="el" href="errors_8c_source.html#l00329">throw_exception()</a>.</p>

</div>
</div>
<a class="anchor" id="a3cae90a91b95e5365e192179877cccf9"></a><!-- doxytag: member="errors.c::timeout_error" ref="a3cae90a91b95e5365e192179877cccf9" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned int <a class="el" href="errors_8c.html#a3cae90a91b95e5365e192179877cccf9">timeout_error</a> = 16</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="errors_8c_source.html#l00113">113</a> of file <a class="el" href="errors_8c_source.html">errors.c</a>.</p>

<p>Referenced by <a class="el" href="errors_8c_source.html#l00136">get_exception_name()</a>.</p>

</div>
</div>
<a class="anchor" id="a18b35523d2702706b86f2ab8ae2393d2"></a><!-- doxytag: member="errors.c::user_exception_error" ref="a18b35523d2702706b86f2ab8ae2393d2" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned int <a class="el" href="include_2polylib_2arithmetique_8h.html#a18b35523d2702706b86f2ab8ae2393d2">user_exception_error</a> = 4</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="errors_8c_source.html#l00111">111</a> of file <a class="el" href="errors_8c_source.html">errors.c</a>.</p>

<p>Referenced by <a class="el" href="errors_8c_source.html#l00136">get_exception_name()</a>.</p>

</div>
</div>
</div>
<hr size="1"/><address style="text-align: right;"><small>Generated on Wed Nov 25 17:45:26 2009 for polylib by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.6.1 </small></address>
</body>
</html>
